/***************************************************************************
* La meteo locale extraite du site internet par ESP32, Filtrée ajustée     *
* et affichée par un écran TTGO ! Extraction de données                    * 
* le site : http://api.openweathermap.org/data/2.5/weather?q= , Ce site    *          
* avec une incription gratuite permet d'extraire des données au format     *
* convertibles et extractibles ...                                         *
*Attention de penser à ajuster le fichier "User_Setup_Select.h" dans la    *
* library TFT_eSPI en ajoutant // devant la ligne //#include <User_Setup.h>*
*et en validant la ligne #include <User_Setups/Setup25_TTGO_T_Display.h>   *
* pour adapter le setup au TTGO_T_Display                                  *
***************************************************************************/

#include <SPI.h>
#include <ArduinoJson.h>          //https://github.com/bblanchon/ArduinoJson.git
#include <NTPClient.h>           //https://github.com/taranais/NTPClient

#include <TFT_eSPI.h> // Graphics and font library for ILI9341 driver chip 

#include <WiFi.h>
#include <WiFiUdp.h>
#include <HTTPClient.h>

TFT_eSPI tft = TFT_eSPI();  // Invoke library, pins defined in User_Setup.h

const char* ssid     = "VotreBox-XxXx";// A MODIFIER PAR VOTRE SSID 
const char* password = "LaCleDeLaBoxDeLaVotre";// A MODIFIER PAR VOTRE PASSE
String town="Dallas";// A MODIFIER PAR VOTRE VILLE 
String Country="FR";// A MODIFIER SI AUTRE PAYS
const String endpoint = "http://api.openweathermap.org/data/2.5/weather?q="+town+","+Country+"&units=metric&lang=fr&APPID=";
const String key = "LaCleObtenueLorsDeLInscriptionSurLeSite"; // A MODIFIER PAR LA CLEF DE L'API
String payload=""; // Chaine de caractère entière extraite par json 
String tmp="" ; // temperature
String tmpMin=""; // température mini
String tmpMax=""; // température maxi
String pres="" ; // Pression
String wind="" ; // Vent
String deg="" ;// Sens du vent
String hum="" ; // humidité
String meteo="" ; // nuageux, soleil, couvert, etc
int windSens; // Vitesse du vent en Km/h

// Variables pour l'extraction de l'heure
String formattedTime;
StaticJsonDocument<1000> doc;

// Defini le NTP Client
WiFiUDP ntpUDP;
NTPClient timeClient(ntpUDP);
 
// Variables de boucle et de status des boutons
int i=0;
int count=0;

 void setup(void) {
// Affichage pour le suivi du processus de connexion   
  tft.init();
  tft.setRotation(1);
  tft.fillScreen(TFT_BLACK);
  tft.setTextColor(TFT_WHITE);
  tft.setTextSize(2);
  tft.print("amazing-vacuum-tubes.com     ");
  tft.print("Connecting to ");
  tft.println(ssid);
  WiFi.begin(ssid, password);
  
  while (WiFi.status() != WL_CONNECTED) {
    delay(300);
    tft.print(".");
  }
  
  tft.println("");
  tft.println("WiFi connected.");
  tft.println("IP address: ");
  tft.println(WiFi.localIP());
  delay(5000);

//Préparation du fond de l'afficheur
  tft.setRotation(0);
  tft.fillScreen(TFT_BLACK);
  tft.setTextSize(1);
  tft.setCursor(25, 230);
  tft.setTextColor(TFT_WHITE);
    tft.println(WiFi.localIP());// Adresse ip en bas d'écran
  tft.setTextColor(TFT_WHITE);// Couleur des 4 titres
  tft.setTextSize(1);
  tft.setCursor(80, 135);
    tft.println("GIROUETTE");
  tft.setCursor(80, 85);
    tft.println("BAROMETRE");
  tft.setCursor(4, 85);
    tft.println("TEMPERAT.");
  tft.setCursor(4, 135);
    tft.println("HUMIDITE");

//Affichage du bled choisi
  tft.setTextColor(TFT_YELLOW);
  tft.setTextSize(2);
  tft.setCursor(32, 25); // A ajuster suivant longueur du mot
    tft.println(town);
  tft.fillRect(0,70,135,3,TFT_BLUE);// trait separateur en bas (horizontal)
  tft.fillRect(67,70,3,90,TFT_BLUE);// trait separateur en bas (vertical)
 
// Initialise le NTPClient pour avoir l'heure
  timeClient.begin(); 
  getData();
  delay(500);
}

 
void loop() {
    
// Boucle d'affichage
      count++;
   if(count>30){ // Rafrechissement cyclique ~30 minutes (à ajuster suivant besoin)
    count=0;
    getData();}// Va vers le Sous programme d'extraction et mise en forme des valeurs avant affichage

      tft.setTextSize(2);
      tft.setTextColor(TFT_WHITE);
      tft.setCursor(5,100);
        tft.println(tmp.substring(0,4));//avec 1 chiffre après la virgule
       tft.setCursor(2, 150);
         tft.println(hum+"%");
       tft.setCursor(75,100);
         tft.println(pres);

// Couleur suivant le sens du vent 
    windSens=(deg.toInt()); //Remplace la chaine de caractère en valeur
      if ((windSens > 300 )and (windSens < 30 )) {
          tft.setTextColor(TFT_WHITE);
      } 
      if ((windSens > 29)and (windSens <120) ) {
          tft.setTextColor(TFT_BLUE);
      }
      if ((windSens > 119 )and(windSens < 240)) {
          tft.setTextColor(TFT_RED);
      }
      if ((windSens > 239) and (windSens < 301)) {
          tft.setTextColor(TFT_GREEN);
      }
          tft.setCursor(80, 150);
          tft.println(wind.substring(0,3));

// Affichage de la tempéraure Mini maxi  

      tft.fillRect(0,180,55,40,TFT_BLACK);//Fond de la température
      tft.setTextSize(2);
      tft.setTextColor(TFT_WHITE);
      if(tmpMin.toInt() < 2) {tft.setTextColor(TFT_BLUE);} // En bleu, risque de gelée
      if(tmpMax.toInt() > 28) {tft.setTextColor(TFT_RED);} // En rouge, il va faire chaud
      tft.setCursor(3, 180);
        tft.println(tmpMin.substring(0,4)+" C mini");
      tft.setCursor(3, 200);
        tft.println(tmpMax.substring(0,4)+" C maxi");

// Mise à jour de l'horloge, tant que ...toujours            
   while(!timeClient.update()) {
    //timeClient.forceUpdate();
  }

     
// L'heure arrive ainsi: 16:00:13
      formattedTime = timeClient.getFormattedTime();
      tft.fillRect(0,0,135,20,TFT_RED);
      tft.setTextColor(TFT_WHITE);
      tft.setTextSize(2);
      tft.setCursor(30, 1);
        tft.println(formattedTime.substring(0,5)); 
     delay(300);             
}


 
void getData()//Mise en forme
{ 
// Effacement cyclique des données par affichage d'un rectangle noir sur chacune   
  tft.fillRect(0,100,55,20,TFT_BLACK);//--------------------- Backround de la température
  tft.fillRect(0,150,55,20,TFT_BLACK);//--------------------- Backround de l'humidité
  tft.fillRect(75,100,55,20,TFT_BLACK);//--------------------- Backround de la Pression
  tft.fillRect(75,150,55,20,TFT_BLACK);//--------------------- Backround du vent
delay (300);
   
   if ((WiFi.status() == WL_CONNECTED)) { //Contrôle de l'état de la connexion
    HTTPClient http;
    http.begin(endpoint + key); //Specifie l' URL
    int httpCode = http.GET();  //Formule la demande
      if (httpCode > 0) payload = http.getString();
    http.end(); //Libère les ressources
  }

 char inp[1000];
 payload.toCharArray(inp,1000);
 deserializeJson(doc,inp);
 
 //Offset de l'heure en secondes pour ajuster mon timezone
  // GMT +1 = 3600
  // GMT +2 = 7200
  int Decalage=doc["timezone"]; // heure locale ( en été = 7200)
  timeClient.setTimeOffset(Decalage);
  
  String tmp2 = doc["main"]["temp"];
  String tmp3 = doc["main"]["temp_min"];
  String tmp4 = doc["main"]["temp_max"];
  String pres2 = doc["main"]["pressure"];
  String wind2 = doc["wind"]["speed"];
  String deg2 = doc["wind"]["deg"];
  String hum2 = doc["main"]["humidity"];
  String town2 = doc["name"];
  tmp=tmp2;
  tmpMin=tmp3;
  tmpMax=tmp4;
  hum=hum2;
  pres=pres2;
  wind=((wind2.toInt())* 3.6); //Remplace la chaine de caractère et les m/s par Km/h
  deg=deg2;
   
//On sort la meteo en cours 
  String meteo1 = doc["weather"];//                                     
  int test = meteo1.indexOf("description")+14; //14 = chaque lettre du mot après "description" en comptant les guillemets !
  String meteo2 = meteo1.substring(test,test+meteo1.length()-1);
  test = meteo2.indexOf(",")-1;

//Sortie de la meteo mais avec des accents
  String meteo = meteo2.substring(0,test);

//    REMPLACEMENT DES ACCENTS PAR LES LETTRES SANS ACCENT
  meteo.replace("é", "e");
  meteo.replace("è", "e");
  meteo.replace("ê", "e");
  meteo.replace("à", "a");

// Affichage de la météo
 tft.fillRect(0,50,128,20,TFT_BLACK);//--------------------- Backround noir de la météo en lettres 
 tft.setCursor(1, 50);
 tft.setTextSize(2);
 tft.setTextColor( TFT_GREEN);//
  tft.println(meteo.substring(0,11));//avec 11 caractères
 } 
 
